//+------------------------------------------------------------------+
//|                                              GannSwingsVIII.mq5  |
//|                                          Copyright  2005, Rosh  |
//|                                       http://www.metaquotes.net  |
//+------------------------------------------------------------------+
//--- copyright
#property copyright "Copyright  2005, Rosh"
//--- link to the website of the author
#property link "http://www.metaquotes.net"
//--- indicator version
#property version   "1.00"
//--- drawing the indicator in the main window
#property indicator_chart_window
//--- six buffers are used for calculation of drawing of the indicator
#property indicator_buffers 6
//--- five graphical plots are used
#property indicator_plots   5
//+-----------------------------------------------+
//| Zigzag indicator drawing parameters           |
//+-----------------------------------------------+
//--- drawing the indicator as a section
#property indicator_type1   DRAW_SECTION
//--- gold color is used for the indicator line
#property indicator_color1 clrGold
//--- the indicator line is a continuous curve
#property indicator_style1  STYLE_SOLID
//--- indicator line width is 2
#property indicator_width1  2
//--- displaying the indicator label
#property indicator_label1  "BinaryWave"
//+----------------------------------------------+
//| Bullish indicator drawing parameters         |
//+----------------------------------------------+
//--- drawing the indicator 2 as a label
#property indicator_type2   DRAW_ARROW
//--- blue color is used for the indicator line
#property indicator_color2  clrBlue
//--- the indicator 2 line is a dot-dash one
#property indicator_style2  STYLE_DASHDOTDOT
//--- indicator 2 line width is equal to 2
#property indicator_width2  2
//--- displaying of the the indicator label
#property indicator_label2  "Upper"
//+----------------------------------------------+
//| Parameters of drawing the bearish indicator  |
//+----------------------------------------------+
//--- drawing the indicator 3 as a label
#property indicator_type3   DRAW_ARROW
//--- medium violet red color is used for the indicator line
#property indicator_color3  clrMediumVioletRed
//--- the indicator 3 line is a dot-dash one
#property indicator_style3  STYLE_DASHDOTDOT
//--- indicator 3 line width is equal to 2
#property indicator_width3  2
//--- displaying of the the indicator label
#property indicator_label3  "Lower"
//+----------------------------------------------+
//| Bullish indicator drawing parameters         |
//+----------------------------------------------+
//--- drawing the indicator 4 as a label
#property indicator_type4   DRAW_ARROW
//--- DeepSkyBlue color is used for the indicator
#property indicator_color4  clrDeepSkyBlue
//--- indicator 4 width is equal to 1
#property indicator_width4  1
//--- displaying the indicator label
#property indicator_label4  "Buy"
//+----------------------------------------------+
//| Parameters of drawing the bearish indicator  |
//+----------------------------------------------+
//--- drawing the indicator 5 as a label
#property indicator_type5   DRAW_ARROW
//--- magenta color is used for the indicator
#property indicator_color5  clrMagenta
//--- indicator 5 width is equal to 1
#property indicator_width5  1
//--- displaying the indicator label
#property indicator_label5  "Sell"
//+----------------------------------------------+
//|  declaration of enumerations                 |
//+----------------------------------------------+
enum Type
  {
   LITTLE=1,   // small
   MIDLE,      // intermediate
   MAIN        // main
  };
//+----------------------------------------------+
//| Indicator input parameters                   |
//+----------------------------------------------+
input Type  kind=LITTLE;          // Trend type
input bool  MoveLastSwing=false;  // Shift of the zigzag tail to the zero bar for two identical bars by High or Low
input int   Shift=0;              // Horizontal shift of the indicator in bars
//+----------------------------------------------+
//--- declaration of dynamic arrays that will be used as indicator buffers
double SwingsBuffer[];
double HighsBuffer[];
double LowsBuffer[];
double TrendBuffer[];
double UpCloseOutSideBuffers[];
double DownCloseOutSideBuffers[];
//---
double SwingHigh,SwingLow;
int LastSwing,lowCounter,highCounter;
//--- declaration of integer variables for the start of data calculation
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//--- initialization of variables of data calculation start
   min_rates_total=2;
//--- set dynamic array as an indicator buffer
   SetIndexBuffer(0,SwingsBuffer,INDICATOR_DATA);
//--- shifting the indicator horizontally by Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//--- shifting the start of drawing of the indicator
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(SwingsBuffer,true);
//--- setting the indicator values that won't be visible on a chart
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
//--- set dynamic array as an indicator buffer
   SetIndexBuffer(1,HighsBuffer,INDICATOR_DATA);
//--- shifting the indicator horizontally by Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//--- shifting the start of drawing of the indicator
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(HighsBuffer,true);
//--- setting the indicator values that won't be visible on a chart
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
//--- indicator symbol
   PlotIndexSetInteger(1,PLOT_ARROW,159);
//--- set dynamic array as an indicator buffer
   SetIndexBuffer(2,LowsBuffer,INDICATOR_DATA);
//--- shifting the indicator horizontally by Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//--- shifting the start of drawing of the indicator
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(LowsBuffer,true);
//--- setting the indicator values that won't be visible on a chart
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);
//--- indicator symbol
   PlotIndexSetInteger(2,PLOT_ARROW,159);
//--- set dynamic array as an indicator buffer
   SetIndexBuffer(3,UpCloseOutSideBuffers,INDICATOR_DATA);
//--- shifting the indicator horizontally by Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//--- shifting the start of drawing of the indicator
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(UpCloseOutSideBuffers,true);
//--- setting the indicator values that won't be visible on a chart
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
//--- indicator symbol
   PlotIndexSetInteger(3,PLOT_ARROW,108);
//--- set dynamic array as an indicator buffer
   SetIndexBuffer(4,DownCloseOutSideBuffers,INDICATOR_DATA);
//--- shifting the indicator horizontally by Shift
   PlotIndexSetInteger(4,PLOT_SHIFT,Shift);
//--- shifting the start of drawing of the indicator
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(DownCloseOutSideBuffers,true);
//--- setting the indicator values that won't be visible on a chart
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,0);
//--- indicator symbol
   PlotIndexSetInteger(4,PLOT_ARROW,108);
//--- set dynamic array as a buffer for data saving
   SetIndexBuffer(5,TrendBuffer,INDICATOR_CALCULATIONS);
//--- indexing buffer elements as timeseries   
   ArraySetAsSeries(TrendBuffer,true);
//--- creation of the name to be displayed in a separate sub-window and in a pop up help
   IndicatorSetString(INDICATOR_SHORTNAME,"GannSwingsVIII");
//--- determining the accuracy of the indicator values
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//--- initialization end
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    // number of bars in history at the current tick
                const int prev_calculated,// amount of history in bars at the previous tick
                const datetime &Time[],
                const double &Open[],
                const double& High[],     // price array of price maximums for the indicator calculation
                const double& Low[],      // price array of price minimums for the indicator calculation
                const double &Close[],
                const long &Tick_Volume[],
                const long &Volume[],
                const int &Spread[])
  {
//--- checking if the number of bars is enough for the calculation
   if(rates_total<min_rates_total) return(0);
//--- declarations of local variables 
   int limit,bar,maxbar;
   bool nonOutSide;
//--- indexing elements in arrays as in timeseries  
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(Open,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
//---
   maxbar=rates_total-min_rates_total-1;
//--- calculation of the 'limit' starting index for the bars recalculation loop
   if(prev_calculated>rates_total || prev_calculated<=0) // checking for the first start of calculation of an indicator
     {
      limit=maxbar;
      lowCounter=0;
      highCounter=0;                                  // starting index for calculation of all bars
      LowsBuffer[limit]=Low[limit];
      SwingsBuffer[limit]=High[limit];
      SwingsBuffer[limit]=Low[limit];
      SwingHigh=High[limit];
      SwingLow=Low[limit];
      LastSwing=0;
      TrendBuffer[limit+1]=-1.0;
      TrendBuffer[limit]=-1.0;
     }
   else
     {
      limit=rates_total-prev_calculated;                 // starting index for calculation of new bars
     }
//--- Restore values of the variables
   LastSwing+=limit;
//--- main indicator calculation loop
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      if(bar!=maxbar)
        {
         UpCloseOutSideBuffers[bar]=0.0;
         DownCloseOutSideBuffers[bar]=0.0;
         SwingsBuffer[bar]=0.0;
         HighsBuffer[bar]=0.0;
         LowsBuffer[bar]=0.0;
        }
      //---
      nonOutSide=!((High[bar]>High[bar+1]) && (Low[bar]<Low[bar+1]));
      if(!nonOutSide)
        {
         if(Close[bar]>Open[bar]) UpCloseOutSideBuffers[bar]=(High[bar]+Low[bar])/2.0;
         else DownCloseOutSideBuffers[bar]=(High[bar]+Low[bar])/2.0;
        }
      //---
      if(High[bar]>SwingHigh)
        {
         highCounter++;
         SwingHigh=High[bar];
         HighsBuffer[bar]=SwingHigh;
        }
      //---
      if(Low[bar]<SwingLow)
        {
         lowCounter++;
         SwingLow=Low[bar];
         LowsBuffer[bar]=SwingLow;
        }
      //---
      TrendBuffer[bar]=TrendBuffer[bar+1];// if there are no changes, the trend continues
      if(TrendBuffer[bar+1]==-1.0 && lowCounter==1)// && nonOutSide) 
        {
         if(LastSwing!=maxbar) SwingsBuffer[LastSwing]=0.0; // then the previous swing
         LastSwing=bar;
         SwingHigh=High[bar];
         SwingLow=Low[bar];
         highCounter=0;
         lowCounter=0;
         SwingsBuffer[bar]=Low[bar];Print("-----------------W");
         HighsBuffer[bar]=SwingHigh;
        }
      else
        {
         if(TrendBuffer[bar+1]==-1.0 && highCounter==kind)
           {
            LastSwing=bar;
            SwingHigh=High[bar];
            SwingLow=Low[bar];
            TrendBuffer[bar]=+1.0;
            highCounter=0;
            lowCounter=0;
            SwingsBuffer[bar]=High[bar];Print("-----------------E");
            LowsBuffer[bar]=SwingLow;
           }
         else
           {
            if(TrendBuffer[bar+1]==-1.0 && Low[bar]==SwingLow && MoveLastSwing)
              {
               SwingsBuffer[LastSwing]=0.0;
               LastSwing=bar;
               SwingsBuffer[bar]=Low[bar];
              }
           }
        }
      if(TrendBuffer[bar+1]==+1.0 && highCounter==1)// && nonOutSide) 
        {
         if(LastSwing!=maxbar) SwingsBuffer[LastSwing]=0.0; // then the previous swing
         LastSwing=bar;
         SwingHigh=High[bar];
         SwingLow=Low[bar];
         highCounter=0;
         lowCounter=0;
         SwingsBuffer[bar]=High[bar];
         LowsBuffer[bar]=SwingLow;
         // Uptrend continuation
        }
      else
        {
         if(TrendBuffer[bar+1]==+1.0 && lowCounter==kind)
           {
            LastSwing=bar;
            SwingHigh=High[bar];
            SwingLow=Low[bar];
            TrendBuffer[bar]=-1.0;
            highCounter=0;
            lowCounter=0;
            SwingsBuffer[bar]=Low[bar];
            HighsBuffer[bar]=SwingHigh;
            // Uptrend turn
           }
         else
           {
            if(TrendBuffer[bar+1]==1.0 && High[bar]==SwingHigh && MoveLastSwing)
              {
               SwingsBuffer[LastSwing]=0.0;
               LastSwing=bar;
               SwingsBuffer[bar]=High[bar];
              }
           }
        }
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
